#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char *argv[])
{
	// parametres d entree
	int nPluie,nCouche;
	double th_cc,*apportEau,val;
	double *dz,*thCI;
	double *date;
	// variable de sortie
	double *th,drainage,storage;
	// variables locales
	FILE *fPluie,*fIn,*fOut;
	int i,j;
	double apportActu;
	char nomPluie[150],nomIn[150],nomOut[150];

    if (argc!=3)
	{
		printf("Erreur : entrer en argument le repertoire de travail \n");
		return;
	}

	strcpy(nomPluie,argv[1]);
	strcat(nomPluie,"/Pluvio_3_1997_06_05.txt");
	// lecture du fichier pluie
	fPluie = fopen(nomPluie,"r");
	nPluie = 541;
	apportEau = (double*) calloc(nPluie,sizeof(double));
	date      = (double*) calloc(6,sizeof(double));
	for (i=0;i<nPluie;i++) {
		for (j=0;j<6;j++)
			fscanf(fPluie,"%lf",&date[j]);
		fscanf(fPluie,"%lf \n",&apportEau[i]);
	}
	fclose(fPluie);

	strcpy(nomIn,argv[1]);
	strcat(nomIn,"/input.txt");
	// lecture des parametres
	fIn = fopen(nomIn,"r");
	fscanf(fIn,"%lf\n",&th_cc);
	fscanf(fIn,"%d\n",&nCouche);
	dz   = (double*) calloc(nCouche,sizeof(double));
	thCI = (double*) calloc(nCouche,sizeof(double));
	for (i=0;i<nCouche;i++) {
		fscanf(fIn,"%d %lf %lf\n",&j,&dz[i],&thCI[i]);
	}
	fclose(fIn);

	// calculs : repartition de l apport sur les couches de sol
	th       = (double*) calloc(nCouche,sizeof(double));
	for (j=0;j<nCouche;j++)
		th[j] = 0;
	drainage = 0;
	printf("pas de temps  |  apport  |  stock   | drainage |\n");
	for (i=0;i<nPluie;i++) {
		apportActu = apportEau[i];
		for (j=0;j<nCouche;j++) {
			if (apportActu>=(th_cc-thCI[j])*dz[j]) {
				th[j]      = th_cc;
				apportActu -= (th_cc-thCI[j])*dz[j];
			}
			else {
				th[j]      = thCI[j] + apportActu/dz[j];
				apportActu = 0;
			}
		}
		drainage += apportActu;
		for (j=0;j<nCouche;j++)
			thCI[j] = th[j];
		storage = 0;
		for (j=0;j<nCouche;j++)
			storage += th[j]*dz[j];
		printf("%14d|%10.4lf|%10.4lf|%10.4lf|\n",i+1,apportEau[i],storage,drainage);
	}

	strcpy(nomOut,argv[2]);
	strcat(nomOut,"/out_c.txt");
	// enregistrement des resultats
	fOut = fopen(nomOut,"w");
	for (i=0;i<nCouche;i++) {
		fprintf(fOut,"%4d %10.4lf %10.4lf\n",i+1,dz[i],th[i]);
	}
	fprintf(fOut,"%10.4lf\n",drainage);

	fclose(fOut);

	return 0;
}
