#include <stdio.h>
#include <stdlib.h>
#include "ReservoirCCalc.h"

int ReservoirCCalc(int n,double th_cc, double *thCI, double *dz, double *apport, double *storage, double *drainage)
{
	int i,k;
	double Theta[n];
	double apportActu,stockDispo;

	apportActu = *apport;
	for (i=0;i<n;i++) {
		stockDispo = (th_cc - thCI[i]) * dz[i];
		if (apportActu>=stockDispo) {
			Theta[i]   = th_cc;
			apportActu = apportActu - stockDispo;
		}
		else {
			Theta[i]   = thCI[i] + apportActu/dz[i];
			apportActu = 0.0;
		}
	}
	*drainage = *drainage + apportActu;

	/*mise à jour des valeurs de th ini pour le pas de temps suivant
	 * avec les valeurs de th du pas de temps en cours
	 */

	*storage = 0;
	for (k=0;k<n;k++)
	{
		thCI[k] = Theta[k];
		*storage = *storage + Theta[k] * dz[k];
	}

	return 0;
}
