subroutine ReservoirFortranCalc(n,th_cc,thCI,dz,apport,storage,drainage)

    implicit none

    ! variables en argument
    integer,intent(in)         :: n
    real(kind=8),intent(in)    :: th_cc,dz(n),apport
    real(kind=8),intent(inout) :: thCI(n),storage,drainage

    ! variables  locales
    real(kind=8) :: Theta(n),apportActu,stockDispo
    integer      :: i

    ! calculs : repartition de l'apport sur les couches de sol

    apportActu = apport
    do i=1,n
        stockDispo = (th_cc - thCI(i)) * dz(i)
        if (apportActu.GE.stockDispo) then
            Theta(i) = th_cc
            apportActu = apportActu - stockDispo
        else
            Theta(i) = thCI(i) + apportActu / dz(i)
            apportActu = 0d0
        end if
    end do

    drainage = drainage + apportActu

! mise à jour des valeurs de th ini pour le pas de temps suivant avec les valeurs de th du pas de temps en cours

    thCI    = Theta
    storage = sum(Theta*dz)

end subroutine ReservoirFortranCalc
